package com.sun.org.apache.bcel.internal.generic;

import com.sun.org.apache.bcel.internal.util.ByteSequence;
import java.io.IOException;
import java.io.DataOutputStream;

public class GOTO_W extends GotoInstruction
{
    GOTO_W() {
    }
    
    public GOTO_W(InstructionHandle target) {
        super((short)200, target);
        super.setLength(5);
    }
    
    @Override
    public void dump(DataOutputStream out) throws IOException {
        super.setIndex(this.getTargetOffset());
        out.writeByte((int)super.getOpcode());
        out.writeInt(super.getIndex());
    }
    
    @Override
    protected void initFromFile(ByteSequence bytes, boolean wide) throws IOException {
        super.setIndex(bytes.readInt());
        super.setLength(5);
    }
    
    @Override
    public void accept(Visitor v) {
        v.visitUnconditionalBranch(this);
        v.visitBranchInstruction(this);
        v.visitGotoInstruction(this);
        v.visitGOTO_W(this);
    }
}
